//+------------------------------------------------------------------+
//|                                                       trevor.mq4 |
//+------------------------------------------------------------------+

extern double Lots=0.10;
extern double Reverse_Lots_Multiplier=0;
extern int Bar_Hour=9;
extern int TP=30;
extern int BreakEven_Point=-30;
extern int BreakEven_Offset=0;
extern int Long_BreakOut=5;
extern int Short_BreakOut=5;
extern int Stop_Hour=1;

extern int Magic_Number=700;
extern int Slippage=3;

string com="trevor bar breakout";
datetime lasttrade=0;

int TotalOrders(int magic){
   int rez=0;
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==magic){
         rez++;
      }
   }   
   return(rez);
}

string error(int err){
switch (err){
 case 0 :return("No error returned.");
 case 1 :return("No error returned, but the result is unknown. ");
 case 2 :return("Common error. ");
 case 3 :return("Invalid trade parameters. ");
 case 4 :return("Trade server is busy. ");
 case 5 :return("Old version of the client terminal. ");
 case 6 :return("No connection with trade server. ");
 case 7 :return("Not enough rights. ");
 case 8 :return("Too frequent requests."); 
 case 9 :return("Malfunctional trade operation. ");
 case 64 :return("Account disabled. ");
 case 65 :return("Invalid account. ");
 case 128 :return("Trade timeout. ");
 case 129 :return("Invalid price. ");
 case 130 :return("Invalid stops. ");
 case 131 :return("Invalid trade volume. ");
 case 132 :return("Market is closed. ");
 case 133 :return("Trade is disabled. ");
 case 134 :return("Not enough money. ");
 case 135 :return("Price changed. ");
 case 136 :return("Off quotes. ");
 case 137 :return("Broker is busy."); 
 case 138 :return("Requote. ");
 case 139 :return("Order is locked. ");
 case 140 :return("Long positions only allowed. ");
 case 141 :return("Too many requests. ");
 case 145 :return("Modification denied because order too close to market. ");
 case 146 :return("Trade context is busy. ");
 case 147 :return("Expirations are denied by broker. ");
 case 148 :return("The amount of open and pending orders has reached the limit set by the broker. ");
 case 4000 :return("No error. ");
 case 4001 :return("Wrong function pointer. ");
 case 4002 :return("Array index is out of range. ");
 case 4003 :return("No memory for function call stack. ");
 case 4004 :return("Recursive stack overflow. ");
 case 4005 :return("Not enough stack for parameter. ");
 case 4006 :return("No memory for parameter string. ");
 case 4007 :return("No memory for temp string. ");
 case 4008 :return("Not initialized string. ");
 case 4009 :return("Not initialized string in array. ");
 case 4010 :return("No memory for array string. ");
 case 4011 :return("Too long string. ");
 case 4012 :return("Remainder from zero divide. ");
 case 4013 :return("Zero divide. ");
 case 4014 :return("Unknown command. ");
 case 4015 :return("Wrong jump (never generated error). ");
 case 4016 :return("Not initialized array. ");
 case 4017 :return("DLL calls are not allowed. ");
 case 4018 :return("Cannot load library. ");
 case 4019 :return("Cannot call function. ");
 case 4020 :return("Expert function calls are not allowed. ");
 case 4021 :return("Not enough memory for temp string returned from function. ");
 case 4022 :return("System is busy (never generated error). ");
 case 4050 :return("Invalid function parameters count. ");
 case 4051 :return("Invalid function parameter value. ");
 case 4052 :return("String function internal error. ");
 case 4053 :return("Some array error. ");
 case 4054 :return("Incorrect series array using. ");
 case 4055 :return("Custom indicator error. ");
 case 4056 :return("Arrays are incompatible. ");
 case 4057 :return("Global variables processing error. ");
 case 4058 :return("Global variable not found. ");
 case 4059 :return("Function is not allowed in testing mode. ");
 case 4060 :return("Function is not confirmed. ");
 case 4061 :return("Send mail error. ");
 case 4062 :return("String parameter expected. ");
 case 4063 :return("Integer parameter expected. ");
 case 4064 :return("Double parameter expected. ");
 case 4065 :return("Array as parameter expected. ");
 case 4066 :return("Requested history data in updating state. ");
 case 4067 :return("Some error in trading function. ");
 case 4099 :return("End of file. ");
 case 4100 :return("Some file error."); 
 case 4101 :return("Wrong file name. ");
 case 4102 :return("Too many opened files. ");
 case 4103 :return("Cannot open file. ");
 case 4104 :return("Incompatible access to a file. ");
 case 4105 :return("No order selected. ");
 case 4106 :return("Unknown symbol. ");
 case 4107 :return("Invalid price. ");
 case 4108 :return("Invalid ticket. ");
 case 4109 :return("Trade is not allowed. ");
 case 4110 :return("Longs are not allowed. ");
 case 4111 :return("Shorts are not allowed. ");
 case 4200 :return("Object exists already. ");
 case 4201 :return("Unknown object property. ");
 case 4202 :return("Object does not exist. ");
 case 4203 :return("Unknown object type. ");
 case 4204 :return("No object name. ");
 case 4205 :return("Object coordinates error. ");
 case 4206 :return("No specified subwindow. ");
 case 4207 :return("Some error in object function. ");
 default: return("Unknown error:"+err);
}
}

bool Open_Positive(int m,int type){
   int i;
   for(i=0;i<OrdersHistoryTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if (OrderMagicNumber()==m   && 
          TimeCurrent()-OrderOpenTime()<=3600*24 && 
          TimeDay(OrderOpenTime())==TimeDay(TimeCurrent()) && 
          TimeDayOfWeek(OrderOpenTime()!=0) &&
          ((OrderClosePrice()==OrderTakeProfit()) || 
          (OrderType()==type)) && 
          (OrderType()==OP_SELL || OrderType()==OP_BUY)){
         return (true);
      }        
   }
   return(false);
}      

int init(){return(0);}
int deinit(){return(0);}
int start()
  {
   if (TimeHour(TimeCurrent())>=Bar_Hour+1 && DayOfWeek()!=0){
      int i=0;
      double Bar_High=0;
      double Bar_Low=0;
      double last_lot=0;
      for (i=0;i<24;i++){
         if (TimeHour(Time[i])==Bar_Hour){
            Bar_High=High[i];
            Bar_Low=Low[i];
            break;
         }
      }     
      if (TotalOrders(Magic_Number)==0 && (lasttrade==0 || Time[0]>lasttrade)){
         if (Ask>=Bar_High+Long_BreakOut*Point && !Open_Positive(Magic_Number,OP_BUY)){
            if (OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),Slippage,0,NormalizeDouble(Ask+TP*Point,Digits),com,Magic_Number,0,Blue)==-1) {
               i=GetLastError();
               if (i!=1 && i!=0) Alert("Buy Error :"+error(i)+" at "+Symbol()+" "+Period());
            }else{
               lasttrade=Time[0];
            }           
         }
         if (Bid<=Bar_Low-Short_BreakOut*Point && !Open_Positive(Magic_Number,OP_SELL)){
            if (OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),Slippage,0,NormalizeDouble(Bid-TP*Point,Digits),com,Magic_Number,0,Red)==-1) {
               i=GetLastError();
               if (i!=1 && i!=0) Alert("Sell Error :"+error(i)+" at "+Symbol()+" "+Period());
            }else{
               lasttrade=Time[0];
            }
         }                  
      }
      if (TotalOrders(Magic_Number)>0){
         for (i=0;i<OrdersTotal();i++){
            OrderSelect(i,SELECT_BY_POS);
            if (OrderMagicNumber()==Magic_Number) {
               break;
            }
         }
         if (Ask>=Bar_High+Long_BreakOut*Point && OrderMagicNumber()==Magic_Number && OrderType()==OP_SELL){
            last_lot=OrderLots();
            if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Pink))
               if (last_lot==Lots && (lasttrade==0 || Time[0]>lasttrade) && Reverse_Lots_Multiplier>=0)
               if (OrderSend(Symbol(),OP_BUY,last_lot*Reverse_Lots_Multiplier,NormalizeDouble(Ask,Digits),Slippage,0,NormalizeDouble(Ask+TP*Point,Digits),com,Magic_Number,0,Blue)==-1) {
                  i=GetLastError();
                  if (i!=1 && i!=0) Alert("Buy Error :"+error(i)+" at "+Symbol()+" "+Period());
               }else{
                   lasttrade=Time[0];
               }  
         }
         if (Bid<=Bar_Low-Short_BreakOut*Point && OrderMagicNumber()==Magic_Number && OrderType()==OP_BUY){
            last_lot=OrderLots();       
            Alert("sa"+(Bar_Low-Short_BreakOut*Point)+" fd "+Bid);
            if (OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Pink))         
               if (last_lot==Lots && (lasttrade==0 || Time[0]>lasttrade) && Reverse_Lots_Multiplier>=0)
               if (OrderSend(Symbol(),OP_SELL,last_lot*Reverse_Lots_Multiplier,NormalizeDouble(Bid,Digits),Slippage,0,NormalizeDouble(Bid-TP*Point,Digits),com,Magic_Number,0,Red)==-1) {
                  i=GetLastError();
                  if (i!=1 && i!=0) Alert("Sell Error :"+error(i)+" at "+Symbol()+" "+Period());
               }else{
                   lasttrade=Time[0];
               }  
         }                  
         if (Ask>=OrderOpenPrice()+((BreakEven_Point+BreakEven_Offset)*Point) && OrderMagicNumber()==Magic_Number && OrderType()==OP_BUY){
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+BreakEven_Point*Point,Digits),OrderTakeProfit(),0,Brown)){
                  i=GetLastError();
                  if (i!=1 && i!=0) Alert("Buy Breakeven Error :"+error(i)+" at "+Symbol()+" "+Period());            
            }
         }
         if (Bid<=OrderOpenPrice()-((BreakEven_Point+BreakEven_Offset)*Point) && OrderMagicNumber()==Magic_Number && OrderType()==OP_SELL){
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-BreakEven_Point*Point,Digits),OrderTakeProfit(),0,Brown)){
                  i=GetLastError();
                  if (i!=1 && i!=0) Alert("Sell Breakeven Error :"+error(i)+" at "+Symbol()+" "+Period());            
            }
         }         
      }         
      
   }
   if (TotalOrders(Magic_Number)>0){
      for (i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS);
         if ((TimeHour(Time[0])>=Stop_Hour && Stop_Hour>Bar_Hour) || (TimeDay(OrderOpenTime())<TimeDay(TimeCurrent()) && TimeHour(Time[0])>=Stop_Hour )){
         if (OrderMagicNumber()==Magic_Number && OrderType()==OP_BUY ){
         Alert("fdsa"+(Bar_Low-Short_BreakOut*Point)+" fd "+Bid);
            if (!OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Pink)) {
                  i=GetLastError();
                  if (i!=1 && i!=0) Alert("24 Hour Buy close Error :"+error(i)+" at "+Symbol()+" "+Period());                        
            }         
            break;   
         }
         if (OrderMagicNumber()==Magic_Number && OrderType()==OP_SELL){
            if (!OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Pink)) {
                  i=GetLastError();
                  if (i!=1 && i!=0) Alert("24 Hour Sell close Error :"+error(i)+" at "+Symbol()+" "+Period());                        
            }            
            break;
         }         
         }
      }
   }
      
   return(0);
  }

